#!/usr/bin/perl -w

require '/var/smoothwall/header.pl';

my %cgiparams;

@shortmonths = ( 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug',
	'Sep', 'Oct', 'Nov', 'December' );
@longmonths = ( 'January', 'Februrary', 'March', 'April', 'May', 'June',
	'July', 'August', 'September', 'October', 'November', 'December' );
%filters = ( 'ppp' => '(pppd|chat)\[.*\]', 'dhcp' => '(dhcpd)',
	'kernel' => '(kernel)');

print "Content-type: text/html\n\n";

$cgiparams{'SECTION'} = 'ppp';
$temp = `/bin/date +%m`; $temp =~ s/[0\n]//g;
$cgiparams{'MONTH'} = $temp - 1;
$temp = `/bin/date +%d`; $temp =~ s/[0\n]//g;
$cgiparams{'DAY'} = $temp;
&getcgihash(\%cgiparams);

$selected{'SECTION'}{'ppp'} = '';
$selected{'SECTION'}{'dhcp'} = '';
$selected{'SECTION'}{'kernel'} = '';
$selected{'SECTION'}{$cgiparams{'SECTION'}} = 'SELECTED';

&openpage('Smoothwall - Log viewer');
&openbigbox('100%', 'LEFT');

&openbox('100%', 'LEFT', 'Section and date:');

print "<FORM METHOD='POST'>\n";
print "<TABLE WIDTH='100%'>\n";
print "<TR>\n";
print "<TD>Section:</TD><TD>\n";
print "<SELECT NAME='SECTION'>\n";
print "<OPTION $selected{'SECTION'}{'ppp'} VALUE='ppp'>PPP\n";
print "<OPTION $selected{'SECTION'}{'dhcp'} VALUE='dhcp'>DHCP server\n";
print "<OPTION $selected{'SECTION'}{'kernel'} VALUE='kernel'}>Kernel\n";
print "</SELECT>\n";
print "</TD>\n";
print "<TD>Month:</TD>\n";
print "<TD>\n";
print "<SELECT NAME='MONTH'>\n";
for ($month = 0; $month < 12; $month++)
{
	print "<OPTION ";
	if ($month == $cgiparams{'MONTH'}) {
		print 'SELECTED '; }
	print "VALUE='$month'>$longmonths[$month]\n";
}
print "</SELECT>\n";
print "</TD>\n";
print "<TD>Day:</TD>\n";

print "<TD>\n";
print "<SELECT NAME='DAY'>\n";
for ($day = 1; $day <= 31; $day++) 
{
	print "<OPTION ";
	if ($day == $cgiparams{'DAY'}) {
		print 'SELECTED '; }
	print "VALUE='$day'>$day\n";
}
print "</SELECT>\n";
print "</TD>\n";
print "<TD><INPUT TYPE='submit' NAME='ACTION' VALUE='Update'></TD>\n";
print "</TR>\n";
print "</TABLE>\n";
print "</FORM>\n";

&closebox();

$monthstr = $shortmonths[$cgiparams{'MONTH'}];
$day = $cgiparams{'DAY'};
if ($day <= 9) {
	$daystr = " $day"; }
else {
	$daystr = $day; }

$filter = $filters{$cgiparams{'SECTION'}};

&openbox('100%', 'LEFT', 'Log:');
open (FILE, '/var/log/messages');
print "<TT>\n";
while (<FILE>)
{
	if (/^${monthstr} ${daystr} (..:..:..) \w+ ${filter}: (.*)/)
	{
		print "$1 $2 $3<BR>\n";
	}
}
print "</TT>\n";
close (FILE);
print "&nbsp;\n";
&closebox();

print <<END
<DIV ALIGN='CENTER'>
<TABLE WIDTH='60%'>
<TR><TD ALIGN='CENTER'>
<A HREF='/cgi-bin/index.cgi'>BACK</A>
</TD></TR></TABLE>
</DIV>
END
;

&closebigbox();

&closepage();
